Attribute VB_Name = "modConversions"
Option Explicit

'Extremely useful in converting Strings to Longs and Ints and vice-versa
Private Declare Sub RtlMoveMemory Lib "kernel32" (Dest As Any, Src As Any, ByVal cb&)

'So I don't have to declare a temporary variable all the time.
Private String2 As String * 2, String4 As String * 4, I As Integer, I2 As Integer, I3 As Integer, L As Long

'Return an Integer stored in the given string
Public Function GetInteger(RawText As String) As Integer
RtlMoveMemory I, ByVal RawText, 2
GetInteger = I
End Function

'Return a Long stored in the given string
Public Function GetLong(RawText As String) As Long
RtlMoveMemory L, ByVal RawText, 4
GetLong = L
End Function

'Return a string representing a Long
Public Function GetStringL(L As Long) As String
RtlMoveMemory ByVal String4, L, 4
GetStringL = String4
End Function

'Return a string representing an Integer
Public Function GetStringI(I As Integer) As String
RtlMoveMemory ByVal String2, I, 2
GetStringI = String2
End Function

'Return RawText + X number of chr(0)s
Public Function FillZero(RawText As String, DesiredLength) As String
If DesiredLength = Len(RawText) Then
 FillZero = RawText
ElseIf DesiredLength > Len(RawText) Then
 FillZero = RawText + String(DesiredLength - Len(RawText), Chr(0))
Else
 FillZero = Left(RawText, DesiredLength)
End If
End Function

'Return RawText without any chr(0)s on the right
Public Function TrimZero(RawText As String) As String
I = InStr(RawText, Chr(0))
If I > 0 Then
 TrimZero = Left(RawText, I - 1)
Else
 TrimZero = RawText
End If
End Function

'Return the current day, month and year as a Long
Public Function GetDateString() As String
GetDateString = Chr(Day(Date)) + Chr(Month(Date)) + GetStringI(Year(Date))
End Function

'year, month, day, hour, minute, second [12 bytes]
'Creation Date/Time, for the ?usage. Used once when added a new user to User Database
Public Function GetDateTimeString() As String
GetDateTimeString = GetStringI(Year(Date)) + GetStringI(Month(Date)) + GetStringI(Day(Date)) + GetStringI(Hour(Time)) + GetStringI(Minute(Time)) + GetStringI(Second(Time))
End Function

'gives dd/mm/yyyy from ascii date string
Public Function GetDateFormat(RawText As String) As String
GetDateFormat = CStr(Asc(Left(RawText, 1))) + "-" + CStr(Asc(Mid(RawText, 2, 1))) + "-" + CStr(GetInteger(Mid(RawText, 3, 2)))
End Function

'Get the dotted format for a String IP
Public Function GetIPFormat(RawText As String) As String
GetIPFormat = CStr(Asc(Mid(RawText, 1, 1))) + "." + CStr(Asc(Mid(RawText, 2, 1))) + "." + CStr(Asc(Mid(RawText, 3, 1))) + "." + CStr(Asc(Mid(RawText, 4, 1)))
End Function

Public Function GetIPString(IP As String) As String
I = InStr(IP, ".")
If I > 0 Then
 I2 = InStr(I + 1, IP, ".")
 If I2 > 0 Then
  I3 = InStr(I2 + 1, IP, ".")
  If I3 > 0 Then GetIPString = Chr(Val(Left(IP, I - 1))) & Chr(Val(Mid(IP, I + 1, I2 - I - 1))) & Chr(Val(Mid(IP, I2 + 1, I3 - I2 - 1))) & Chr(Val(Mid(IP, I3 + 1)))
 End If
End If
End Function

'Get current session ID. It's a number which identifies packets. Then increment that number
Public Function MessagesSentCount(ServerIndex As Long) As String
With Server(ServerIndex)
RtlMoveMemory ByVal String4, .MessagesSentCount, 4 'this is faster than calling the whole GetString() function. what we are doing is converting MessagesSentCount to a 4 character string
If .MessagesSentCount = 2147483647 Then .MessagesSentCount = -1 'prevent the overflow error. i don't care if client stops responding, at lease biller won't crash
.MessagesSentCount = .MessagesSentCount + 1 'Increment afterwards: always starts at zero
MessagesSentCount = String4
End With
End Function
