Attribute VB_Name = "modStartUp"
Option Explicit

Private Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private b As Byte

Function GetProfile(Section As String, Key As String) As String
Dim s As String * 255
b = GetPrivateProfileStringA(Section, Key, "", ByVal s, 255, GetLongFileName(App.Path, App.Title & ".ini"))
If b > 0 Then GetProfile = Left(s, b)
End Function

'For some reason if some strings are blank and are tried to be saved, their keys aren't even made, but for other blank string variables, the keys are made. So I used FillZero() function and it worked
Sub SetProfile(Section As String, Key As String, Value As String)
WritePrivateProfileStringA Section, Key, FillZero(Value, 255), GetLongFileName(App.Path, App.Title & ".ini")
End Sub

Private Sub DefaultVariables()
LastAutoSave = Time
End Sub

Private Sub LoadINI()
On Error Resume Next
Open GetLongFileName(App.Path, App.Title & ".ini") For Input As #1
 If Err > 0 Then
  Open GetLongFileName(App.Path, App.Title & ".ini") For Append As #1
  Print #1, "[Misc]"
  Print #1, "// If 0, a zone op that's not a biller MessageOp can send arena message to all zones connected to this biller"
  Print #1, "// If 1, a zone op must also be a biller MessageOp to send arena message to all zones connected to this biller"
  Print #1, "ZonecastLock=1"
  Print #1, "LogTerminal=0"
  Print #1, "// This greeting will be given to player after 30 seconds of loging in. [Default] is the default message"
  Print #1, "Greeting=[Default]"
  Print #1, "// Periodically all connected zones' databases will be saved to disk. Shortest time is 30 seconds."
  Print #1, "AutoSave=01:00:00"
  Print #1,
  Print #1, "[Login]"
  Print #1, "// The port that Zone Servers may connect to (this should be in their server.ini under [Billing] section)"
  Print #1, "Port=4000"
  Print #1, "// Can new Zones connect without being added to [RegisteredZones] section by a biller operator?"
  Print #1, "AllowNewZones=1"
  Print #1, "AllowNewUsers=1"
  Print #1, "AskNewUsers=1"
  Print #1,
  Print #1, "[Passwords]"
  Print #1, "// Unregistered zones will need to have this password in their server.ini under [Billing] section"
  Print #1, "BillingPassword=billingbob"
  Print #1, "MessageOpPassword=messagingbob"
  Print #1, "AccountOpPassword=accountingbob"
  Print #1, "SysOpPassword=sysingbob"
  Print #1,
  Print #1, "[RegisteredZones]"
  Print #1, "// If AllowNewZones=0, only zones listed under this section are allowed to connect to this billing server"
  Print #1, "// Format: ServerName(from server.ini)=new biller password(should match one in server.ini under [Billing] section)"
 End If
Close 1

LogTerminal = Val(GetProfile("Misc", "LogTerminal"))
Greeting = GetProfile("Misc", "Greeting")
AutoSave = GetProfile("Misc", "AutoSave")

Port = Val(GetProfile("Login", "Port"))
AllowNewZones = Val(GetProfile("Login", "AllowNewZones"))
AllowNewUsers = Val(GetProfile("Login", "AllowNewUsers"))
AskNewUsers = Val(GetProfile("Login", "AskNewUsers"))
End Sub

Sub Main()
If App.PrevInstance Then End

frmTerminal.Caption = App.Title

AddTerminal App.Title & " " & App.Major

DefaultVariables

LoadINI

frmTerminal.Show

Dim L As Long
UDPStartWinsock
L = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)
Sock.sin_family = AF_INET
Sock.sin_port = htons(Port)
Sock.sin_addr = 0
bind L, Sock, 16&
SockID = L
WSAAsyncSelect SockID, WinsockWindow, 5150&, FD_READ

AddTerminal "Biller port " & Port & " is open. Waiting for Game Server(s) connection"
End Sub

Sub AddTerminal(mStr As String)
If TerminalLines < Screen.Height / frmTerminal.TextHeight("x") Then
 TerminalLines = TerminalLines + 1
 ReDim Preserve Terminal(1 To TerminalLines)
Else
 For b = 1 To TerminalLines - 1
  Terminal(b) = Terminal(b + 1)
 Next
End If

Terminal(TerminalLines) = Date & " " & Time & " " & mStr

UpdateTerminal

If LogTerminal Then
 On Error GoTo ErrHandler
 ChDrive App.Path: ChDir App.Path
 Open "Terminal.log" For Append As #1
  Print #1, Terminal(TerminalLines)
ErrHandler:
 Close 1
End If
End Sub

Sub UpdateTerminal()
Dim linesshow As Byte, th As Integer
th = frmTerminal.TextHeight("x")
linesshow = Abs(frmTerminal.ScaleHeight - th * 2) / th
If linesshow > TerminalLines Then linesshow = TerminalLines
frmTerminal.Cls
frmTerminal.CurrentY = th
For b = 1 + TerminalLines - linesshow To TerminalLines
 frmTerminal.Print " "; Terminal(b)
Next
End Sub
